<template>
  <single-pane>
    <ob-table
        ref="subscriptions-table"
        :columns="columns"
        :sub-columns="subColumns"
        :functionalPanel="true"
        :remote-opt="getSubscriptions"
        :sub-remote-opt="{
          method: ($event) => getTypeDirection($event)
        }"
        :add-button-text="'Добавить подписку'"
        :sub-table-action="{}"
        :tableLayoutFixed="false"
        :is-functional-filter="false"
        :is-functional-group="false"
        :is-functional-sort="false"
        :is-smart-pagination="false"
        :loading="loading"
        :show-add-button="true"
        is-sub-table-action
        :is-fixed-header="role !== 'moderator'"
        toggle-sub-table-by-click-at-whole-row
        class="subscriptions"
        @add="showModal(true, {})"
    >

      <!-- Columns -->

      <!-- Тип подписки -->

      <template v-slot:typeSubscriptions="{ data }">
        <div v-if="data.item.type === 'SHIPMENT_POINTS'">
          <i class="icon pin --blue"/> По точкам отгрузки
        </div>
        <div v-else>
          <i class="icon route --blue"/> Откуда/Куда
        </div>
      </template>

      <!-- Автор -->

      <template v-slot:author="{ data }">
        {{ formatAuthor(data.item.author) }}
      </template>

      <!-- Последние изменения -->

      <template v-slot:updatedAt="{ data }">
        {{ data.item.updatedAt | date('DD.MM.YYYY') }}
        <span class="--grey">{{ data.item.updatedAt | date('HH:mm') }}</span>
      </template>

      <!-- Опорники -->

      <template v-slot:support="{ data }">
        <span class="--grey">Опорников: {{ getSupporter(data.item) }}</span>
      </template>

      <!-- Шестеренка -->

      <template v-slot:editSlot="{ data }">
        <i
            class="icon settings --blue"
            title="Настройки"
            @click="showModal(false, data.item)"
            @mousedown.stop
            @mouseup.stop
        />
      </template>

      <!-- Sub columns -->

      <template v-slot:column="{ data }">

        <!-- Учитывать заказы -->

        <div v-if="data.item.slotColumn === 'order'" class="subscriptions-column">
          <div class="subscriptions-column__title">
            {{data.item.nameColumn}}
          </div>
          <div class="subscriptions-column__checkbox"></div>
          <div class="subscriptions-column__items">
            <direction
              :subscription="data.item"
              @changeType="changeType"
            />
          </div>
        </div>

        <!-- Откуда / По точкам отгрузки -->

        <div v-if="data.item.slotColumn === 'fromLocations'" class="subscriptions-column">
          <div class="subscriptions-column__title">
            {{data.item.nameColumn}}
          </div>
          <div class="subscriptions-column__checkbox">
            <ObCheckbox
              v-model="data.item.fromLocations.isAll"
              @change="changeCheckFromLocation(data.item)"
            />
          </div>
          <points
              :items="getListFromLocation(data.item.fromLocations)"
              :icon="'city-sm'"
              :subscription="data.item"
              :type="'location'"
              :toggle="data.item.fromLocations.fromLocationUuids.length !== 1"
              @remove="removeFromLocations"
          />
        </div>

        <!-- Куда -->

        <div v-if="data.item.slotColumn === 'toLocations'" class="subscriptions-column">
          <div class="subscriptions-column__title">
            {{data.item.nameColumn}}
          </div>
          <div class="subscriptions-column__checkbox">
            <ObCheckbox
                v-model="data.item.toLocations.isAll"
                @change="changeCheckToLocation(data.item)"
            />
          </div>
          <points
              :items="getListToLocation(data.item.toLocations)"
              :subscription="data.item"
              :toggle="data.item.toLocations.toLocationUuids.length !== 1"
              @remove="removeToLocations"
          />
        </div>

        <!-- Период действия -->

        <div v-if="data.item.slotColumn === 'period'" class="subscriptions-column">
          <div class="subscriptions-column__title">
            {{data.item.nameColumn}}
          </div>
          <div class="subscriptions-column__checkbox"></div>
          <validity
            :key="`${data.item.slotColumn}_${data.item.updatedAt}`"
            :subscription="data.item"
            @set-date="saveSubscription"
          />
        </div>

        <!-- Заказы клиентов -->

        <div v-if="data.item.slotColumn === 'customers'" class="subscriptions-column">
          <div class="subscriptions-column__title">
            {{data.item.nameColumn}}
          </div>
          <div class="subscriptions-column__checkbox"></div>
          <OrderCustom
            :subscription="data.item"
            class="subscriptions-column__items"
            @setClients="setClients"
            @showModal="showModal(false, data.item)"
          />
        </div>

        <!-- Услуги -->

        <div v-if="data.item.slotColumn === 'service'" class="subscriptions-column">
          <div class="subscriptions-column__title">
            {{data.item.nameColumn}}
          </div>
          <div class="subscriptions-column__checkbox">
            <ObCheckbox
                :value="checker(data.item.serviceUuid, data.item)"
                @change="setService(data.item.serviceUuid, data.item)"
            />
          </div>
          <ServicePoints
              :service-uuid="data.item.serviceUuid"
              :subscription="data.item"
              @delete="deleteService"
          />
        </div>

      </template>

    </ob-table>

    <ObModal
      ref="edit-modal"
      :title="isNew ? 'Добавление' : 'Редактирование'"
      :titleSecond="'Параметры подписки'"
      size="medium"
      :is-submit-disabled="false"
      :ok-text="isNew ? 'Добавить' : 'Сохранить'"
    >
      <template slot="footer">
        <EditSubscription
          ref="isModal"
          :key="modalKey"
          :is-new="isNew"
          :subscription="subscriptionData"
          @sendData="saveSubscription"
          @close="closeModal"
        />
        <div
          v-if="!isNew"
          class="subscriptions--delete-btn"
          @click="$refs['delete-subscription'].open()"
        >
          Удалить подписку
        </div>
      </template>

    </ObModal>

    <ob-modal
        ref="delete-subscription"
        size="medium"
        title="Удаление подписки"
        ok-text="Да, удалять"
        cancel-text="Не удалять"
        is-error
        is-show-controls
        is-confirm
        @submit="deleteSubscription"
    >
      <div class="subscriptions--text-delete">Подписка: {{subscriptionData.title}}</div>
      <div class="subscriptions--text-delete">Данная подписка будет удалена</div>
    </ob-modal>

  </single-pane>
</template>

<script>
  import SinglePane from 'common-components/src/obComponents/obSinglePanels';
  import ObTable from 'common-components/src/obComponents/obTable';
  import Points from './components/subscriptionPoints';
  import ServicePoints from './components/ServicePoints';
  import OrderCustom from './components/ordersCustom';
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox';
  import Direction from './components/direction';
  import Validity from './components/validity';
  import ObModal from 'common-components/src/obComponents/obModal';
  import EditSubscription from './modals/editSubscription/index';
  import { mapGetters, mapActions, mapMutations } from 'vuex';
  import api from "@/api";
  import cloneDeep from 'clone-deep';

  export default {
    name: "ListSubscriptions",
    components: {
      SinglePane,
      ObTable,
      ObCheckbox,
      Direction,
      Points,
      OrderCustom,
      Validity,
      ServicePoints,
      ObModal,
      EditSubscription
    },

    data() {
      return {
        loading: false,
        isNew: true,
        subscriptionData: {},
        modalKey: '',
      }
    },
    computed: {
      ...mapGetters({
        services: 'subscriptions/services',
        listLocations: 'subscriptions/listLocations',
        listClients: 'subscriptions/listClients',
        userUuid: 'user/participantUuid',
        role: 'user/role'
      }),
      performerUuid() {
        return document.location.pathname.split('/').pop()
      },
      columns() {
        return [
          {
            title: 'НАИМЕНОВАНИЕ ПОДПИСКИ',
            key: 'title'
          },
          {
            title: '',
            key: '',
            html: () => '',
            width: 90
          },
          {
            title: 'Тип подписки',
            key: 'typeSubscriptions',
            slotName: 'typeSubscriptions'
          },
          {
            title: 'Автор',
            key: 'author',
            slotName: 'author'
          },
          {
            title: 'Последние изменения',
            key: 'updatedAt',
            slotName: 'updatedAt'
          },
          {
            title: '',
            key: 'support',
            slotName: 'support'
          },
          {
            title: '',
            key: 'edit',
            slotName: 'editSlot'
          }
        ]
      },
      subColumns () {
        return [
          {
            key: 'uuid',
            slotName: 'column'
          }
        ]
      }
    },
    async mounted() {
      await this.getListServices();
      await this.getListLocations();
      await this.getListClients(this.userUuid);
    },
    methods: {
      ...mapActions({
        getListServices: 'subscriptions/getListServices',
        getListLocations: 'subscriptions/getListLocations',
        getListClients: 'subscriptions/getListClients'
      }),
      ...mapMutations({
        setSubscription: 'subscriptions/SET_SUBSCRIPTION',
        clearSubscription: 'subscriptions/CLEAR_SUBSCRIPTION'
      }),
      showModal (status, data) {
        this.modalKey = `modal_${+ new Date()}`
        this.subscriptionData = cloneDeep(data)
        this.isNew = status;
        // await this.$nextTick()

        this.$refs['edit-modal'].open()

        if (!status) {
          this.setSubscription(data);
        }
      },
      async getSubscriptions () {
        return await api.subscriptions.showSubscriptions(this.role === 'moderator' ? this.performerUuid : '')
      },
      async getTypeDirection ({item}) {
        const data = await this.getSubscriptions();
        const flag = data.find(key => key.uuid === item.uuid);
        const fromTo = [
          {
            nameColumn: 'Учитывать заказы',
            slotColumn: 'order',
            ...flag
          },
          {
            nameColumn: 'Откуда',
            slotColumn: 'fromLocations',
            ...flag
          },
          {
            nameColumn: 'Куда',
            slotColumn: 'toLocations',
            ...flag
          }
        ];
        const byPoints = [
          {
            nameColumn: 'По точкам отгрузки',
            slotColumn: 'fromLocations',
            ...flag
          },
        ];
        const services = this.services.reduce((array, value) => {
          array.push(
            {
              nameColumn: value.title,
              slotColumn: 'service',
              serviceUuid: value.uuid,
              ...flag
            }
          );
          return array;
        }, []);
        return [
          ...flag.type === 'SHIPMENT_POINTS' ? byPoints : fromTo,
          {
            nameColumn: 'Период действия',
            slotColumn: 'period',
            ...flag
          },
          {
            nameColumn: 'Заказы от клиентов',
            slotColumn: 'customers',
            ...flag
          },
          ...services
        ]

      },
      formatAuthor(author) {
        return author ?
          `${author.firstname ? author.firstname : ''}
            ${author.lastname ? author.lastname : ''}
            ${author.patronymic ? author.patronymic : ''}`
          : '';
      },
      getSupporter ({fromLocations, toLocations, type}) {
        const from = fromLocations.isAll ? this.listLocations.length : fromLocations.fromLocationUuids.length;
        const to = type === 'SHIPMENT_POINTS' ? 0 : toLocations.isAll ?
          this.listLocations.length : toLocations.toLocationUuids.length;
        return from + to;
      },
      changeCheckFromLocation (subscription) {
        let data = cloneDeep(subscription);
        if (data.fromLocations.isAll) {
          data.fromLocations.fromLocationUuids = [];
        } else {
          data.fromLocations.fromLocationUuids = this.listLocations.map(key => key.uuid);
        }
        this.saveSubscription(data)
      },
      changeCheckToLocation (subscription) {
        let data = cloneDeep(subscription);
        if (data.toLocations.isAll) {
          data.toLocations.toLocationUuids = [];
        } else {
          data.toLocations.toLocationUuids = this.listLocations.map(key => key.uuid);
        }
        this.saveSubscription(data)
      },
      async saveSubscription (subscription) {
        delete subscription.isOpenedSubTable;
        delete subscription.nameColumn;
        delete subscription.slotColumn;
        delete subscription.serviceUuid;

        if (['SHIPMENT_POINTS', 'FROM_TO'].includes(subscription.type)) {
          subscription.toLocations = null
        }
        try {
          await api.subscriptions.createSubscription(subscription, this.role === 'moderator' ? this.performerUuid : '')
          this.$refs['edit-modal'].close();
          await this.$nextTick()
          this.$refs['subscriptions-table']?.loadData({ init: true })
          this.$notification({
            type: 'system_notification_success',
            message: this.isNew ? 'Подписка успешно создана' : 'Подписка успешно изменена'
          });
        } catch (err) {
          console.error('Ошибка при редактировании подписки', err);
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка при редактировании подписки'
          })
        }

      },
      async deleteSubscription () {
        try {
          await api.subscriptions.deleteSubscriptions(this.subscriptionData.uuid)
          this.$notification({
            type: 'system_notification_success',
            message: 'Подписка удалена'
          });
          setTimeout(() => {
            this.$refs['subscriptions-table']?.loadData({ init: true })
          }, 500)
          this.$refs['delete-subscription'].close();
          this.$refs['edit-modal'].close();
        } catch (err) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка при удалении подписки'
          })
        }
      },
      closeModal() {
        setTimeout(() => {
          this.$refs['subscriptions-table']?.loadData({ init: true })
        }, 500)
        this.$refs['edit-modal'].close();
      },
      changeType ({type, subscription}) {
        let data = cloneDeep(subscription);
        data.type = type;
        this.saveSubscription(data);
      },
      getListFromLocation ({isAll, fromLocationUuids}) {
        if (isAll) {
          return this.listLocations.map(key => key.uuid);
        }
        return fromLocationUuids;
      },
      removeFromLocations ({uuid, subscription}) {
        let data = cloneDeep(subscription);
        if (data.fromLocations.isAll) {
          let list = cloneDeep(this.listLocations);
          list = list.map(key => key.uuid);
          const index = list.findIndex(key => key === uuid);
          if (index !== -1) {
            list.splice(index, 1);
            data.fromLocations.isAll = false;
            data.fromLocations.fromLocationUuids = list;
            this.saveSubscription(data);
          }
        } else {
          const index = data.fromLocations.fromLocationUuids.findIndex(key => key === uuid);
          if (index !== -1) {
            data.fromLocations.fromLocationUuids.splice(index, 1);
            this.saveSubscription(data);
          }
        }
      },
      getListToLocation ({isAll, toLocationUuids}) {
        if (isAll) {
          return this.listLocations.map(key => key.uuid);
        }
        return toLocationUuids;
      },
      removeToLocations ({uuid, subscription}) {
        let data = cloneDeep(subscription);
        if (data.toLocations.isAll) {
          let list = cloneDeep(this.listLocations);
          list = list.map(key => key.uuid);
          const index = list.findIndex(key => key === uuid);
          if (index !== -1) {
            list.splice(index, 1);
            data.toLocations.isAll = false;
            data.toLocations.toLocationUuids = list;
            this.saveSubscription(data);
          }
        } else {
          const index = data.toLocations.toLocationUuids.findIndex(key => key === uuid);
          if (index !== -1) {
            data.toLocations.toLocationUuids.splice(index, 1);
            this.saveSubscription(data);
          }
        }
      },
      setClients ({isAll, clientUuids, subscription}) {
        let data = cloneDeep(subscription);
        data.clients.isAll = isAll;
        data.clients.clientUuids = clientUuids;
        this.saveSubscription(data);
      },
      checker (uuid, subscription) {
        const check = subscription.services.find(key => key.serviceTypeUuid === uuid);
        if (check) {
          return check.isAll;
        }
        return false;
      },
      getGroup (uuid) {
        return this.services.find(key => key.uuid === uuid);
      },
      setService (uuid, subscription) {
        let data = cloneDeep(subscription);
        const service = data.services.find(key => key.serviceTypeUuid === uuid);
        if (service) {
          let cloneService = cloneDeep(service);
          const index = data.services.findIndex(key => key.serviceTypeUuid === uuid);
          if (index !== -1) {
            const group = this.getGroup(uuid);
            data.services.splice(index, 1);
            if (cloneService.isAll) {
              cloneService.isAll = false;
              cloneService.resourceSubtypeUuids = Array.from(new Set(group.list.map(item => item.resourceSubtypeUuid)));
              cloneService.serviceUuids = group.list.map(key => key.uuid);
            } else {
              cloneService.isAll = true;
              cloneService.resourceSubtypeUuids = [];
              cloneService.serviceUuids = [];
            }
            data.services = [
              ...data.services,
              cloneService
            ];
            this.saveSubscription(data);
          }
        } else {
          data.services = [
            ...data.services,
            {
              serviceTypeUuid: uuid,
              isAll: true,
              resourceSubtypeUuids: [],
              serviceUuids: []
            }
          ];
          this.saveSubscription(data);
        }
      },
      deleteService({service, serviceUuid, subscription}) {
        let data = cloneDeep(subscription);
        let currentService = data.services.find(key => key.serviceTypeUuid === serviceUuid);
        const index = data.services.findIndex(key => key.serviceTypeUuid === currentService.serviceTypeUuid);
        if (index !== -1) {
          data.services.splice(index, 1);
          if (service.length) {
            const serviceUuids = service.map(key => {
              if (key.group) {
                  return key.group.map(item => item.uuid)
              } else {
                  return key.uuid
              }
            });

            const resourceSubtypeUuids = service.map(key => {
              if (key.group) {
                return key.uuid
              } else {
                return key.resourceSubtypeUuid
              }
            });

            data.services = [
              ...data.services,
              {
                isAll: false,
                serviceTypeUuid: currentService.serviceTypeUuid,
                resourceSubtypeUuids: Array.from(new Set(resourceSubtypeUuids)),
                serviceUuids: serviceUuids.flat()
              }
            ]
          }
          this.saveSubscription(data);
        }
      }
    }
  }
</script>

<style lang="scss">
  .subscriptions {
    &-column {
      display: flex;
      align-items: center;
      &__title {
        width: 380px;
      }
      &__checkbox {
        width: 120px;
      }
      &__items {
        width: 740px;
      }
    }
    .--grey {
      color: $gray-slate;
    }
    .--blue {
      color: $color-blue-smalt;
    }

     &--delete-btn {
      font-size: 16px;
      line-height: 20px;
      letter-spacing: 0.4px;
      color: $color-blue-smalt;
      position: absolute;
      bottom: 50px;
      right: 75px;
      cursor: pointer;
    }
  }
</style>
